Index: /trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -36,86 +26,52 @@
  */
 package org.greenstone.gatherer.cdm;
-
-import java.awt.BorderLayout;
-import java.awt.Color;
-import java.awt.Component;
-import java.awt.Dimension;
-import java.awt.GridLayout;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.awt.event.MouseAdapter;
-import java.awt.event.MouseEvent;
-import java.io.BufferedReader;
-import java.io.File;
-import java.io.FileInputStream;
-import java.io.FileOutputStream;
-import java.io.InputStream;
-import java.io.InputStreamReader;
-import java.io.ObjectInputStream;
-import java.io.ObjectOutputStream;
-import java.io.StringReader;
-import java.lang.Exception;
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.Enumeration;
-import java.util.jar.JarFile;
-import javax.swing.BorderFactory;
-import javax.swing.DefaultListCellRenderer;
-import javax.swing.JButton;
-import javax.swing.JComboBox;
-import javax.swing.JLabel;
-import javax.swing.JList;
-import javax.swing.JOptionPane;
-import javax.swing.JPanel;
-import javax.swing.JScrollPane;
-import javax.swing.JTextArea;
-import javax.swing.ListSelectionModel;
-import javax.swing.event.ListSelectionEvent;
-import javax.swing.event.ListSelectionListener;
-import org.apache.xerces.parsers.DOMParser;
+/**************************************************************************************
+ * Written:      01/05/02
+ * Revised:      16/08/02 Optimized and Commented.
+ *               11/07/03 DOM support
+ **************************************************************************************/
+import java.awt.*;
+import java.awt.event.*;
+import java.io.*;
+import java.util.*;
+import java.util.jar.*;
+import javax.swing.*;
+import javax.swing.event.*;
+import org.apache.xerces.parsers.*;
 import org.greenstone.gatherer.Gatherer;
 import org.greenstone.gatherer.cdm.Argument;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
 import org.greenstone.gatherer.cdm.CollectionDesignManager;
 import org.greenstone.gatherer.cdm.CommandTokenizer;
+import org.greenstone.gatherer.cdm.Control;
 import org.greenstone.gatherer.cdm.Classifier;
 import org.greenstone.gatherer.cdm.CustomClassifier;
-import org.greenstone.gatherer.cdm.DynamicListModel;
+import org.greenstone.gatherer.cdm.DOMProxyListModel;
 import org.greenstone.gatherer.file.FileNode;
-import org.greenstone.gatherer.msm.ElementWrapper;
+import org.greenstone.gatherer.gui.GComboBox;
 import org.greenstone.gatherer.msm.MSMEvent;
 import org.greenstone.gatherer.msm.MSMListener;
 import org.greenstone.gatherer.msm.MSMUtils;
 import org.greenstone.gatherer.util.Utility;
-import org.w3c.dom.Document;
-import org.w3c.dom.Node;
-import org.xml.sax.InputSource;
+import org.w3c.dom.*;
+import org.xml.sax.*;
 /** This class is responsible for keeping track of all the classifiers assigned to this collection, and providing methods for adding and removing them.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
  * @version 2.3
  */
-// ####################################################################################
-// Optimization                          Saving
-// ####################################################################################
-// Vector -> ArrayList                   + Memory, + Processor, (pos. - Processor)
-// Unnecessary global references         + Memory (5Kb+)
-// ####################################################################################
 public class ClassifierManager
-    implements MSMListener {
-    /** An interface to the Gatherer, the creator of this cdm module, for access to the Greenstone installation directory. */
-    private Gatherer gatherer = null;
-    /** A reference to the CollectionDesignManager for access to other configuration managers. */
-    private CollectionDesignManager manager = null;
+    extends DOMProxyListModel {
+
+    /** The default size for a label. */
+    static final private Dimension LABEL_SIZE = new Dimension(140, 20);
+
+    /** A list of known, but currently unassigned, classifiers. */
+    private ArrayList library = null;
     /** The controls for editing the contents of this manager. */
     private Control controls = null;
-    /** A list of assigned classifiers. */
-    private DynamicListModel assigned = null;
-    /** A list of known, but currently unassigned, classifiers. */
-    private DynamicListModel reserve = null;
-    /** We may have somehow recieved a classifier command that are, in fact, custom classifiers which can refer to classifiers that haven't been parsed yet, so this holds a list of failed commands which are retried after the loading is complete. */
-    private ArrayList unresolved_commands = null;
+
+    private DOMProxyListModel model;
+
     /** Constructor.
-     * @param gatherer A reference to the <strong>Gatherer</strong> for access to the Dictionary.
-     * @param manager A reference to the <strong>CollectionDesignManager</strong> itself.
-     * @see org.greenstone.gatherer.Gatherer
      * @see org.greenstone.gatherer.cdm.DynamicListModel
      * @see org.greenstone.gatherer.collection.CollectionManager
@@ -123,146 +79,216 @@
      * @see org.greenstone.gatherer.msm.MSMListener
      */
-    public ClassifierManager(Gatherer gatherer, CollectionDesignManager manager) {
-	this.assigned = new DynamicListModel();
-	this.gatherer = gatherer;
-	this.manager = manager;
-	this.unresolved_commands = new ArrayList();
+    public ClassifierManager() {
+	super(CollectionDesignManager.collect_config.getDocumentElement(), CollectionConfiguration.CLASSIFY_ELEMENT, new Classifier());
+	this.model = this;
+	Gatherer.println("ClassifierManager: " + getSize() + " classifiers parsed.");
+	// Reload/Create the library
 	loadClassifiers();
 	saveClassifiers();
-	// Register as a MSMListener.
-	Gatherer.c_man.getCollection().msm.addMSMListener(this);
-    }
-    /** Method to add a new classifier to reserve.
-	  * @param classifier The new <strong>Classifier</strong>.
+    }
+
+    /** Method to add a new classifier to library.
+     * @param classifier The new <strong>Classifier</strong>.
+     * @see org.greenstone.gatherer.cdm.DynamicListModel
+     */
+    public void addClassifier(Classifier classifier) {
+	if(!library.contains(classifier)) {
+	    library.add(classifier);
+	}
+    }
+
+    /** Method to assign a classifier.
+     * @param classifier The base <strong>Classifier</strong> to assign.
+     * @see org.greenstone.gatherer.cdm.DynamicListModel
+     */
+    public void assignClassifier(Classifier classifier) {
+	if(!contains(classifier)) {
+	    Element element = classifier.getElement();
+	    // Locate where we should insert this new classifier. 
+	    Node target_node = CollectionConfiguration.findInsertionPoint(element);
+	    add(root, classifier, target_node);
+	    Gatherer.c_man.configurationChanged();
+	}
+    }
+
+    /** Destructor.
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.cdm.CollectionDesignManager
+     * @see org.greenstone.gatherer.cdm.DynamicListModel
+     */
+    public void destroy() {
+	if(controls != null) {
+	    controls.destroy();
+	    controls = null;
+	}
+	library.clear();
+	library = null;
+    }
+
+    public Classifier getBaseClassifier(String name) {
+	int library_size = library.size();
+	for(int i = 0; i < library_size; i++) {
+	    Classifier classifier = (Classifier) library.get(i);
+	    if(classifier.getName().equals(name)) {
+		return classifier;
+	    }
+	}
+	// No success.
+	return null;
+    }
+
+    /** Method to retrieve the classifier with the given index.
+     * @param index The index of the desired classifier as an <i>int</i>.
+     * @return The requested Classifier or <i>null</i> if no such classifier exists.
+     */
+    public Classifier getClassifier(int index) {
+	if(0 <= index && index < getSize()) {
+	    return (Classifier) getElementAt(index);
+	}
+	return null;
+    }
+    
+    /** Method to retrieve the control for this manager.
+     * @return the Control for editing classifiers
+     */
+    public Control getControls() {
+	if(controls == null) {
+	    // Build controls
+	    this.controls = new ClassifierControl();
+	}
+	return controls;
+    }
+
+    /** Method to move a classifier in the list order.
+     * @param classifier the Classifier you want to move.
+     * @param direction true to move the classifier up, false to move it down.
+     * @param all true to move to move all the way, false for a single step.
+     */
+    public void moveClassifier(Classifier classifier, boolean direction, boolean all) {
+	if(getSize() < 2) {
+	    Gatherer.println("Not enough classifiers to allow moving.");
+	    return;
+	}
+	if(all) {
+	    // Move to top
+	    if(direction) {
+		// Remove the moving classifier
+		remove(classifier);
+		// Retrieve the first classifier
+		Classifier first_classifier = (Classifier) getElementAt(0);
+		// Add the moving classifier before the first classifier
+		addBefore(classifier, first_classifier);
+		first_classifier = null;
+		Gatherer.c_man.configurationChanged();
+	    }
+	    else {
+		// Remove the moving classifier
+		remove(classifier);
+		// And add after last classifier
+		add(getSize(), classifier);
+	    }
+	}
+	else {
+	    // Try to move the classifier one step in the desired direction.
+	    int index = indexOf(classifier);
+	    ///ystem.err.println("Index of " + classifier + " = " + index);
+	    if(direction) {
+		index--;
+		if(index < 0) {
+		    String args[] = new String[2];
+		    args[0] = get("CDM.ClassifierManager.Classifier");
+		    args[1] = classifier.getName();
+		    JOptionPane.showMessageDialog(Gatherer.g_man, get("CDM.Move.At_Top", args), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
+		    return;
+		}
+		remove(classifier);
+		add(index, classifier);
+		Gatherer.c_man.configurationChanged(); 
+	    }
+	    else {
+		index++;
+		if(index >= getSize()) {
+		    String args[] = new String[2];
+		    args[0] = get("CDM.ClassifierManager.Classifier_Str");
+		    args[1] = classifier.getName();
+		    JOptionPane.showMessageDialog(Gatherer.g_man, get("CDM.Move.At_Bottom", args), get("CDM.Move.Title"), JOptionPane.ERROR_MESSAGE);
+		    return;
+		}
+		remove(classifier);
+		add(index, classifier);
+		Gatherer.c_man.configurationChanged();
+	    }
+	}
+    }
+
+    /** This method removes an assigned classifier. I was tempted to call it unassign, but remove is more consistant. Note that there is no way to remove a classifier from the library.
+	  * @param classifier The Classifier to remove
 	  * @see org.greenstone.gatherer.cdm.DynamicListModel
 	  */
-    public void addClassifier(Classifier classifier) {
-	if(!reserve.contains(classifier)) {
-	    reserve.addElement(classifier);
-	}
-    }
-    /** Method to assign a classifier.
-	  * @param classifier The reserve <strong>Classifier</strong> to assign.
-	  * @see org.greenstone.gatherer.cdm.DynamicListModel
+    public void removeClassifier(Classifier classifier) {
+	remove(classifier);
+	Gatherer.c_man.configurationChanged();
+    }
+
+    /** Method to cache the current contents of library (known classifiers) to file.
+     * @see org.greenstone.gatherer.util.Utility
+     */
+    public void saveClassifiers() {
+	try {
+	    FileOutputStream file = new FileOutputStream(Utility.BASE_DIR + "classifiers.dat");
+	    ObjectOutputStream out = new ObjectOutputStream(file);
+	    out.writeObject(library);
+	    out.close();
+	}
+	catch (Exception error) {
+	}
+    }
+
+    /** Retrieve a phrase from the dictionary based on a certain key.
+	  * @param key The search <strong>String</strong>.
+	  * @return The matching phrase from the Dictionary.
 	  */
-    public void assignClassifier(Classifier classifier) {
-	if(!assigned.contains(classifier)) {
-	    assigned.addElement(classifier);
-	    classifier.setManager(this);
-	    gatherer.c_man.configurationChanged();
-	}
-    }
-    /** Method to assign a classifier.
-	  * @param classifier The <strong>CustomClassifier</strong> to assign.
-	  * @see org.greenstone.gatherer.cdm.DynamicListModel
+    private String get(String key) {
+	return get(key, (String[])null);
+    }
+    /** Retrieve a phrase from the dictionary based on a certain key and certain arguments.
+	  * @param key The search <strong>String</strong>.
+	  * @param args A <strong>String[]</strong> used to complete and format the returned phrase.
+	  * @return The matching phrase from the Dictionary.
+	  * @see org.greenstone.gatherer.Dictionary
+	  * @see org.greenstone.gatherer.Gatherer
 	  */
-    public void assignClassifier(CustomClassifier classifier) {
-	if(!assigned.contains(classifier)) {
-	    assigned.addElement(classifier);
-	    classifier.setManager(this);
-	    gatherer.c_man.configurationChanged();
-	}
-    }
-    /** Destructor.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.cdm.CollectionDesignManager
-	  * @see org.greenstone.gatherer.cdm.DynamicListModel
-	  */
-    public void destroy() {
-	// Deregister as a listener
-	if(gatherer.c_man != null && gatherer.c_man.msm != null) {
-	    gatherer.c_man.msm.removeMSMListener(this);
-	}
-	// Null globals
-	assigned = null;
-	controls = null;
-	gatherer = null;
-	manager = null;
-	reserve = null;
-	unresolved_commands = null;
-    }
-    /** Method to retrieve the classifier with the given index.
-	  * @param index The index of the desired classifier as an <i>int</i>.
-	  * @return The requested Classifier as an <strong>Object</strong> or <i>null</i> if no such classifier exists.
-	  * @see org.greenstone.gatherer.cdm.DynamicListModel
-	  */
-    public Object getClassifier(int index) {
-	if(0 <= index && index < assigned.size()) {
-	    return assigned.get(index);
-	}
-	return null;
-    }
-    /** Method to retrieve the named classifier.
-	  * @param name The name of the desired classifier as a <strong>String</strong>.
-	  * @return The requested <strong>Classifier</strong> or <i>null</i> if no such classifier exists.
-	  * @see org.greenstone.gatherer.cdm.DynamicListModel
-	  */
-    public Classifier getClassifier(String name) {
-	for(int i = 0; i < reserve.size(); i++) {
-	    Classifier classifier = (Classifier)reserve.get(i);
-	    if(classifier.getName().equals(name)) {
-		return classifier;
-	    }
-	}
-	// No success.
-	return null;
-    }
-    /** Method to retrieve the control for this manager.
-	  * @return A <strong>JPanel</strong> containing the controls.
-	  */
-    public JPanel getControls() {
-	if(controls == null) {
-	    controls = new Control();
-	}
-	return controls;
-    }
-    /** Called whenever a metadata element changes significantly.
-	  * @param event A <strong>MSMEvent</strong> choc' full of event informationy goodness.
-	  */
-    public void elementChanged(MSMEvent event) {
-	// Don't really care, as the elements dealt with here are all live references so changes like identifier change will propagate immediately.
-    }
-    /** Method to find the index of the given classifier within the assigned classifiers.
-	  * @param classifier The <strong>Classifier</strong> whose index you wish to find.
-	  * @return The index of the classifier as an <i>int</i>, which has a value of -1 if the classifier was not found.
-	  * @see org.greenstone.gatherer.cdm.DynamicListModel
-	  */
-    public int indexOf(Classifier classifier) {
-	for(int i = 0; i < assigned.size(); i++) {
-	    Object elem = assigned.get(i);
-	    if (elem instanceof Classifier) {
-		Classifier sibling = (Classifier)elem;
-		if(sibling.equals(classifier)) {
-		    return i;
-		}
-	    }
-	}
-	return -1;
-    }
-    // these two methods assume that a custome classifier can never be the same as a classifier
-    public int indexOf(CustomClassifier classifier) {
-	for(int i = 0; i < assigned.size(); i++) {
-	    Object elem = assigned.get(i);
-	    if (elem instanceof CustomClassifier) {
-		CustomClassifier sibling = (CustomClassifier) assigned.get(i);
-		if(sibling.equals(classifier)) {
-		    return i;
-		}
-	    }
-	}
-	return -1;
-    }
-    /** Method to invalidate controls after a significant change in the system state.
-	  */
-    public void invalidateControls() {
-	if(controls != null) {
-	    controls.destroy();
-	}
-	controls = null;
-    }
+    private String get(String key, String arg) {
+	String[] args = null;
+	if(arg != null) {
+	    args = new String[1];
+	    args[0] = arg;
+	}
+	return get(key, args);
+    }
+
+    private String get(String key, String[] args) {
+	if(key.indexOf(".") == -1) {
+	    key = "CDM.ClassifierManager." + key;
+	}
+	return Gatherer.dictionary.get(key, args);
+    }
+
+    /** Method to extract just the classifiers name from a file object.
+     * @param classifier The <strong>File</strong> which references a certain classifier.
+     * @return A <strong>String</strong> containing just the classifiers name, without extension.
+     */
+    private String getClassifierName(File classifier) {
+	String name = classifier.getName();
+	if(name.indexOf(".") != -1) {
+	    name = name.substring(0, name.indexOf("."));
+	}
+	return name;
+    }
+
     /** Method to load the details of a single plug-in.
-	  * @param classifier The classifier <strong>File</strong> you wish to load.
-	  */
-    public void loadClassifier(File classifier) {
+     * @param classifier The classifier <strong>File</strong> you wish to load.
+     */
+    private void loadClassifier(File classifier) {
 	///ystem.err.println("Attempting to parse " + classifier.toString());
 	Document document = null;
@@ -274,11 +300,11 @@
 	    if(Utility.isWindows()) {
 		args = new String[4];
-		if(gatherer.config.perl_path != null) {
-		    args[0] = gatherer.config.perl_path;
+		if(Gatherer.config.perl_path != null) {
+		    args[0] = Gatherer.config.perl_path;
 		}
 		else {
 		    args[0] = "Perl.exe";
 		}
-		args[1] = gatherer.config.gsdl_path + "bin" + File.separator + "script" + File.separator + "classinfo.pl";
+		args[1] = Gatherer.config.gsdl_path + "bin" + File.separator + "script" + File.separator + "classinfo.pl";
 		args[2] = "-xml";
 		args[3] = getClassifierName(classifier);
@@ -334,266 +360,11 @@
 	}
 	if(document != null) {
-	    parse(document.getDocumentElement());
-	}
-    }
-    /** Called whenever the metadata value associated to a certain record changes. */
-    public void metadataChanged(MSMEvent event) {
-	FileNode record = event.getRecord();
-	if(record != null) {
-	    for(int i = 0; i < assigned.size(); i++) {
-		Object object = assigned.get(i);
-		if(object instanceof CustomClassifier) {
-		    CustomClassifier classifier = (CustomClassifier) object;
-		    if(!classifier.isProcessing()) { // are we already in the middle of processing??
-			classifier.process(record);
-		    } 
-		}
-	    }
-	}
-    }
-    /** This method attempts to parse a classifier command from a command string taken from the collection configuration file. This process is quite complex as not only must the correct classifier be matched but also all of the parameters given must be legal. If such a command is found, the classifier is immediately assigned.
-	  * @param command The command <strong>String</strong> that may include classifier information.
-	  * @return <i>true</i> if a classifier command was parsed, <i>false</i> otherwise.
-	  * @see org.greenstone.gatherer.cdm.Argument
-	  * @see org.greenstone.gatherer.cdm.Classifier
-	  * @see org.greenstone.gatherer.cdm.CommandTokenizer
-	  */
-    public boolean parse(String command) {
-	String command_lc = command.toLowerCase();
-	if(command_lc.startsWith("classify")) {
-	    CommandTokenizer tokenizer = new CommandTokenizer(command);
-	    if(tokenizer.countTokens() >= 2) {
-		tokenizer.nextToken(); // Throw away 'classifier'
-		String name = tokenizer.nextToken();
-		// Try to locate the classifier with this name.
-		Classifier classifier = getClassifier(name);
-		// And if successful start to parse the arguments.
-		if(classifier != null) {
-		    // Take a copy.
-		    classifier = classifier.copy();
-		    String key = null;
-		    while((key = tokenizer.nextToken()) != null) {
-			// Try to retrieve a matching argument.
-			Argument argument = classifier.getArgument(key);
-			if(argument != null) {
-			    // Set as assigned.
-			    argument.setAssigned(true);
-			    // And if the argument is of a parameter type, parse a parameter.
-			    if(argument.getType() != Argument.FLAG && tokenizer.hasMoreTokens()) {
-				String value = tokenizer.nextToken();
-				ElementWrapper element = null;
-				// special check for metadata
-				if (argument.getType() == Argument.METADATA) {
-				    value = value.replace(':', MSMUtils.NS_SEP);
-				    if (value.indexOf(MSMUtils.NS_SEP)==-1){
-					value = Utility.EXTRACTED_METADATA_NAMESPACE + MSMUtils.NS_SEP + value;
-				    }
-				    // Now retrieve the element this refers to, if available.
-				    element = Gatherer.c_man.getCollection().msm.getElement(value);
-				}
-				if(element != null) {
-				    argument.setElementValue(element);
-				    element = null;
-				}
-				else {
-				    argument.setValue(value);
-				}
-			    }
-			}
-			// Argument cannot be matched.
-			else {
-			    String cur_key = key;
-			    String value = tokenizer.nextToken();
-			    if(value.startsWith("-")) {
-				key = value;
-				value = null;
-			    }
-			    else {
-				key = null;
-			    }
-			    String custom = classifier.getCustom();
-			    if(custom == null) {
-				if(value == null) {
-				    classifier.setCustom(cur_key);
-				}
-				else {
-				    classifier.setCustom(cur_key + " " + value);
-				}
-			    }
-			    else {
-				if(value == null) {
-				    classifier.setCustom(custom + " " + cur_key);
-				}
-				else {
-				    classifier.setCustom(custom + " " + cur_key + " " + value);
-				}
-			    }
-			}
-		    }
-		    assignClassifier(classifier);
-		    return true;
-		}
-		else {
-		    ///ystem.err.println("Unknown classifier");
-		}
-	    }
-	}
-	else if(command_lc.startsWith("customclassifier")) {
-	    unresolved_commands.add(command);
-	    return true;
-	}
-	return false;
-    }
-    /** This method removes an assigned classifier. I was tempted to call it unassign, but remove is more consistant. Note that there is no way to remove a classifier from the reserve.
-	  * @param classifier The Classifier or CustomClassifier, as an <strong>Object</strong>, to remove.
-	  * @see org.greenstone.gatherer.cdm.DynamicListModel
-	  */
-    public void removeClassifier(Object classifier) {
-	assigned.removeElement(classifier);
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method which attempts to reparse obvious classifier commands which previously referenced unresovable Classifiers.
-	  * @see org.greenstone.gatherer.cdm.Classifier
-	  * @see org.greenstone.gatherer.cdm.CommandTokenizer
-	  * @see org.greenstone.gatherer.cdm.CustomClassifier
-	  */
-    public void reparseUnresolved() {
-	for(int i = 0; i < unresolved_commands.size(); i++) {
-	    String command = (String) unresolved_commands.get(i);
-	    CommandTokenizer tokenizer = new CommandTokenizer(command);
-	    if(tokenizer.countTokens() >= 6) {
-		tokenizer.nextToken();// Lose customclassifier
-		// Get class name.
-		String class_name = tokenizer.nextToken();
-		// Parse arguments.
-		String replaces = null;
-		String separations = null;
-		while(tokenizer.hasMoreTokens()) {
-		    String arg_name = tokenizer.nextToken();
-		    if(arg_name.equalsIgnoreCase("-replaces")) {
-			replaces = tokenizer.nextToken();
-		    }
-		    else if (arg_name.equalsIgnoreCase("-separations")){
-			separations = tokenizer.nextToken();
-		    }
-		}
-		try {
-		    replaces = replaces.substring(2);
-		    int index = Integer.parseInt(replaces);
-		    Classifier original = (Classifier)getClassifier(index);
-		    if(original != null) {
-			Class custom_classifier_class = Class.forName("org.greenstone.gatherer.cdm.custom." + class_name);
-			CustomClassifier custom_classifier = (CustomClassifier) custom_classifier_class.newInstance();
-			custom_classifier.setGatherer(gatherer);
-			custom_classifier.recreate(original, separations);
-			assigned.add(index, custom_classifier);
-			assigned.removeElement(original);
-		    }
-		    else {
-			///ystem.err.println("Missing original.");
-		    }
-		}
-		catch (Exception error) {
-		    error.printStackTrace();
-		}
-	    }
-	}
-	// Regardless of if they work, clear the commands.
-	unresolved_commands.clear();
-    }
-    /** Method to cache the current contents of reserve (known classifiers) to file.
-	  * @see org.greenstone.gatherer.util.Utility
-	  */
-    public void saveClassifiers() {
-	try {
-	    FileOutputStream file = new FileOutputStream(Utility.BASE_DIR + "classifiers.dat");
-	    ObjectOutputStream out = new ObjectOutputStream(file);
-	    out.writeObject(reserve);
-	    out.close();
-	}
-	catch (Exception error) {
-	}
-    }
-    /** Called when a metadata set changed significantly.
-	  * @param event A <strong>MSMEvent</strong> containing information about the set change.
-	  */
-    public void setChanged(MSMEvent event) {
-	// Again, we would only worry about this if we contained 'inanimate' references to elements or something, but our references are live, and controls are rebuilt everytime a pop-up is needed.
-    }
-    /** Method used to determine the number of classifiers that have been assigned.
-	  * @return An <i>int</i> which is the number of classifiers.
-	  */
-    public int size() {
-	return assigned.size();
-    }
-    /** Method to print out a block of classifier commands, much like you'd find in a collection configuration file.
-	  * @return A <strong>String</strong> containing a series of classifier commands separated by new lines.
-	  * @see org.greenstone.gatherer.cdm.Classifier
-	  * @see org.greenstone.gatherer.cdm.CustomClassifier
-	  */
-    public String toString() {
-	StringBuffer text = new StringBuffer();
-	for(int i = 0; i < assigned.size(); i++) {
-	    Object object = assigned.get(i);
-	    if(object instanceof Classifier) {
-		Classifier classifier = (Classifier) object;
-		text.append(classifier.toStringConfig());
-	    }
-	    else if(object instanceof CustomClassifier) {
-		CustomClassifier classifier = (CustomClassifier) object;
-		text.append(classifier.getCommand());
-		text.append("\n");
-		text.append(classifier.getCustomCommand(i));
-	    }
-	    text.append("\n");
-	}
-	text.append("\n");
-	return text.toString();
-    }
-    /** Called when a significant change has occured to a value tree for a certain element, however we take no further action.
-	  * @param event A <strong>MSMEvent</strong> containing information relevant to the event.
-	  */
-    public void valueChanged(MSMEvent event) {
-    }
-    /** Retrieve a phrase from the dictionary based on a certain key.
-	  * @param key The search <strong>String</strong>.
-	  * @return The matching phrase from the Dictionary.
-	  */
-    private String get(String key) {
-	return get(key, null);
-    }
-    /** Retrieve a phrase from the dictionary based on a certain key and certain arguments.
-	  * @param key The search <strong>String</strong>.
-	  * @param args A <strong>String[]</strong> used to complete and format the returned phrase.
-	  * @return The matching phrase from the Dictionary.
-	  * @see org.greenstone.gatherer.Dictionary
-	  * @see org.greenstone.gatherer.Gatherer
-	  */
-    private String get(String key, String arg) {
-	String[] args = null;
-	if(arg != null) {
-	    args = new String[1];
-	    args[0] = arg;
-	}
-	if(key.indexOf(".") == -1) {
-	    key = "CDM.ClassifierManager." + key;
-	}
-	return gatherer.dictionary.get(key, args);
-    }
-    /** Method to extract just the classifiers name from a file object.
-	  * @param classifier The <strong>File</strong> which references a certain classifier.
-	  * @return A <strong>String</strong> containing just the classifiers name, without extension.
-	  */
-    private String getClassifierName(File classifier) {
-	String name = classifier.getName();
-	if(name.indexOf(".") != -1) {
-	    name = name.substring(0, name.indexOf("."));
-	}
-	return name;
-    }
+	    parseXML(document.getDocumentElement());
+	}
+    }
+
     /** Method to initially load information from the standard plug-ins within the gsdl Perl library.
-	  * @see org.greenstone.gatherer.cdm.DynamicListModel
-	  * @see org.greenstone.gatherer.util.Utility
-	  */
+     * @see org.greenstone.gatherer.util.Utility
+     */
     private void loadClassifiers() {
 	// Attempt to restore the cached file.
